<?php

class Bootstrap extends Zend_Application_Bootstrap_Bootstrap
{
    protected function _initDoctype()
    {
        $this->bootstrap('view');
        $view = $this->getResource('view');
        $view->doctype('XHTML1_STRICT');
    }
	
	protected function _initRoutes()
	{
	    $ctrl = Zend_Controller_Front::getInstance();
		
		// Set Base url for subfolder.
		$aOptions = $this->getOption('monsterFile');
		$ctrl->setBaseUrl($aOptions['directory']);
		
	    $router = $ctrl->getRouter();

		// link route
	    $router->addRoute(
	            'link',
	            new Zend_Controller_Router_Route('link/:key',
	                                            array('controller' => 'link',
	                                                  'action' => 'index'))
	    );
		// folder route
		$router->addRoute(
	            'folder',
	            new Zend_Controller_Router_Route('folder/:key',
	                                            array('controller' => 'index',
	                                                  'action' => 'index'))
	    );
		// file route
		$router->addRoute(
	            'file',
	            new Zend_Controller_Router_Route('file/:key',
	                                            array('controller' => 'index',
	                                                  'action' => 'file'))
	    );
		
		// download route
		$router->addRoute(
	            'download',
	            new Zend_Controller_Router_Route('download/:key',
	                                            array('controller' => 'index',
	                                                  'action' => 'download'))
	    );
		
		// delete route
		$router->addRoute(
	            'delete',
	            new Zend_Controller_Router_Route('delete/:key',
	                                            array('controller' => 'index',
	                                                  'action' => 'delete'))
	    );
		
		// deleteFolder route
		$router->addRoute(
	            'deletefolder',
	            new Zend_Controller_Router_Route('deletefolder/:key',
	                                            array('controller' => 'index',
	                                                  'action' => 'deletefolder'))
	    );
		
		Zend_View_Helper_PaginationControl::setDefaultViewPartial('controls.phtml');
	}
}