<?php

class InstallController extends Zend_Controller_Action 
{
	protected $_oBootstrap;
	
    public function init()
    {
		// Load application.ini
		$this->_oBootstrap = Zend_Controller_Front::getInstance()->getParam('bootstrap');
	    $aOptions = $this->_oBootstrap->getOptions();
		if ($aOptions['monsterFile']['installationState'] == true)
		{
			//$this->_redirect('/');
		}
    }

    public function indexAction()
    {
		$this->_helper->layout()->setLayout('installation');
		
		$this->_oBootstrap->bootstrap('db');
		$config = $this->_oBootstrap->getResource('db')->getConfig();
		
		$hostname = trim($config['host']);
		$username = trim($config['username']);
		$password = trim($config['password']);
		$database = trim($config['dbname']);
		
		$aDbConnectionState = array();
		$sHtmlSuccess = '<span class="label label-success">Success</span>';
		$sHtmlError = '<span class="label label-important">Error</span>';
		$bErrorOccured = false;
	
		// Check database connection.
		$link = @mysql_connect("$hostname", "$username", "$password");
		if (!$link) 
		{
			$this->view->dbState = $sHtmlError . " Could not connect to the server '" . $hostname . "'";
	        $this->view->dbError =  mysql_error();
			$bErrorOccured = true;
		}
		else
		{
			$this->view->dbState = $sHtmlSuccess . " Successfully connected to the server '" . $hostname . "'";
		}
		
		if ($link && !$database) 
		{
			$this->view->tableState = $sHtmlError . " No database name was given. Available databases:";
			$db_list = mysql_list_dbs($link);
			$bErrorOccured = true;
			$this->view->dbList = $db_list;
		}
		
		// check table.
		if ($database) 
		{
	    	$dbcheck = @mysql_select_db("$database");
			if (!$dbcheck)
			{
	        	$this->view->tableError = mysql_error();
				$bErrorOccured = true;
			}
			else
			{
				$this->view->tableState = $sHtmlSuccess . " Successfully connected to the database '" . $database . "'";
			}
		}
		
		// check folder "files" exists.
		if (!file_exists(APPLICATION_UPLOADS_DIR)) 
		{
			$this->view->fileFolderState = $sHtmlError . ' The folder "files" does not exists';
			$bErrorOccured = true;
		}
		else 
		{
			$this->view->fileFolderState = $sHtmlSuccess . ' The folder "files" exists';
		}
		
		// check folder write permisson.
		if (!is_writeable(APPLICATION_UPLOADS_DIR)) 
		{
			$this->view->fileFolderWriteable = $sHtmlError . ' The folder "files" is not writeable';
			$bErrorOccured = true;
		}
		else 
		{
			$this->view->fileFolderWriteable = $sHtmlSuccess . ' The folder "files" is writeable';
		}
		
		// check monster.ini write permisson.
		if (!is_writeable(APPLICATION_PATH . '/configs/monster.ini')) 
		{
			$this->view->fileConfigWriteable = $sHtmlError . ' The config "monster.ini" is not writeable';
			$bErrorOccured = true;
		}
		else 
		{
			$this->view->fileConfigWriteable = $sHtmlSuccess . ' The config "monster.ini" is writeable';
		}
		
		$this->view->bErrorOccured = $bErrorOccured;
		
		// Create databases.
		if ($bErrorOccured == false)
		{
			$oServiceUpdate1 = new Service_Update_1_0();
			$oServiceUpdate1->update();
			$this->view->bDatabsesCreated = true;
			
			$oServiceUpdate11 = new Service_Update_1_1();
			$oServiceUpdate11->update();
			$this->view->update11State = $sHtmlSuccess . " Update " . $oServiceUpdate11->getVersion() . " installed successfully.";
			
			$oServiceUpdate12 = new Service_Update_1_2();
			$oServiceUpdate12->update();
			$this->view->update12State = $sHtmlSuccess . " Update " . $oServiceUpdate12->getVersion() . " installed successfully.";
			
			$oServiceUpdate13 = new Service_Update_1_3();
			$oServiceUpdate13->update();
			$this->view->update13State = $sHtmlSuccess . " Update " . $oServiceUpdate13->getVersion() . " installed successfully.";
		}
		
		// Load application.ini
		$this->_oBootstrap = Zend_Controller_Front::getInstance()->getParam('bootstrap');
	    $aOptions = $this->_oBootstrap->getOptions();

		// Install Form
		$oForm = new Application_Form_Install();
		
		if ($this->getRequest()->isPost()) 
		{
            $aFormData = $this->getRequest()->getPost();
            if ($oForm->isValid($aFormData)) 
            {
            	$oServiceUser = new Service_User();
				$aFormData['privilege'] = Service_User::PRIVILEGE_ADMIN;
				$oServiceUser->newUser($aFormData);
				
				$this->_setInstalled();
				
				$this->_helper->flashMessenger->setNamespace('success')->addMessage('You have successfully installed MonsterFile.');
				$this->_redirect('/');
			}
		}
		
		$this->view->oForm = $oForm;
	}

	public function startAction()
	{
	    // disable layout and view
	    $this->view->layout()->disableLayout();
	    $this->_helper->viewRenderer->setNoRender(true);
		
		$oServiceUpdate1 = new Service_Update_1_0();
		$oServiceUpdate1->update();
		
		$oServiceUpdate11 = new Service_Update_1_1();
		$oServiceUpdate11->update();
		
		//$this->_setInstalled();
		
		$this->_helper->flashMessenger->setNamespace('success')->addMessage('You have successfully installed MonsterFile.');
		$this->_redirect('/');
	}
	
	private function _setInstalled()
	{
		// Lädt alle Sektionen einer bestehenden Config Datei, und überspringt
		// alle Erweiterungen
		$bootstrap = Zend_Controller_Front::getInstance()->getParam('bootstrap');
    	$aOptions = $bootstrap->getOption('monsterFile');
		
		$config = new Zend_Config_Ini($_SERVER['DOCUMENT_ROOT'] . $aOptions['directory'] . '/application/configs/monster.ini',
		                              null,
		                              array('skipExtends'        => true,
		                                    'allowModifications' => true));
		 
		// Ändere einen Wert
		$config->production->monsterFile->installationState = 'true';
		 
		// Schreibe die Config Datei
		$writer = new Zend_Config_Writer_Ini(array('config'   => $config,
		                                           'filename' => $_SERVER['DOCUMENT_ROOT'] . $aOptions['directory'] . '/application/configs/monster.ini'));
		$writer->write();
	}
}