<?php

class LinkController extends Zend_Controller_Action 
{
    
    public function indexAction()
    {
    	$this->_helper->layout()->setLayout('link');

		$oServiceLink = new Service_Link();
		$oFile = $oServiceLink->getLink($this->_getParam('key'));
		$this->view->oFile = $oFile;
		
		// Load application.ini
		$oBootstrap = Zend_Controller_Front::getInstance()->getParam('bootstrap');
	    $aOptions = $oBootstrap->getOptions();
		$this->view->aOptions = $aOptions;
		
		// Load Settings
		$oServiceSetting = new Service_Setting();
		$this->_aSettings = $oServiceSetting->getSettings();
		$this->view->aSettings = $this->_aSettings;
		
		if ($oFile)
		{
			$oServiceFile = new Service_File();
			$iSize = filesize(APPLICATION_UPLOADS_DIR . '/' . $oFile->file_name);
			$sFileSize = $oServiceFile->getFileSize($iSize);
	
			$this->view->sFileSize = $sFileSize;
			$this->view->sLinkKey = $this->_getParam('key');
		}
		
		// actual url.
		$this->view->sActualLink = urlencode($this->getRequest()->getScheme() . '://' . $this->getRequest()->getHttpHost() . $this->getRequest()->getRequestUri());
		
		$this->render();
	}
	
	public function createAction()
	{
		// Check user permissions.
		$oSessionUser = Service_User::getSessionUser();
		if ($oSessionUser->link != Service_User::FUNCTION_ALLOWED)
		{
			$this->_helper->flashMessenger->setNamespace('error')->addMessage("That's strictly forbidden!.");
			$this->_redirect('/');
		}
		
		// disable layout and view
	    $this->view->layout()->disableLayout();
	    $this->_helper->viewRenderer->setNoRender(true);
		
		$oServiceLink = new Service_Link();
		$sKey = $oServiceLink->createLink($this->_getParam('key'));
		
		$this->_redirect('/link/' . $sKey);
	}
	
	public function downloadAction()
	{
		// disable layout and view
	    $this->view->layout()->disableLayout();
	    $this->_helper->viewRenderer->setNoRender(true);
		
		$oServiceLink = new Service_Link();
		$oFile = $oServiceLink->getLink($this->_getParam('key'));
		
		if (!$oFile)
		{
			$this->_redirect('/');
		}
		
	    header('Content-Type: ' . $oFile->mime_type);
	    header('Content-Disposition: attachment; filename="'. $oFile->name . '.' . $oFile->extension . '"');
		
		$bootstrap = Zend_Controller_Front::getInstance()->getParam('bootstrap');
    	$aOptions = $bootstrap->getOption('monsterFile');
		
	    readfile($_SERVER['DOCUMENT_ROOT'] . $aOptions['directory'] . '/files/' . $oFile->file_name);
		
		// increase download counter
		$oServiceFile = new Service_File();
		$oServiceFile->increaseDownloadCounter($oFile->file_id);
	}
	
	public function removeAction()
	{
		// disable layout and view
	    $this->view->layout()->disableLayout();
	    $this->_helper->viewRenderer->setNoRender(true);
		
		$oServiceLink = new Service_Link();
		$oServiceLink->removeLink($this->_getParam('key'));
		
		$this->_helper->flashMessenger->setNamespace('info')->addMessage('Link has been removed.');		
		$this->_redirect('index/file/key/' . $this->_getParam('key'));
	}
}