<?php

class SettingsController extends Service_Controller_Action 
{
    protected $_oServiceSetting;
	
    public function init() 
    {
    	parent::init();
		
		if ($this->_sPrivilege != Service_User::PRIVILEGE_ADMIN)
		{
			$this->_redirect('/');
		}
		
		$this->_oServiceSetting = new Service_Setting();
    }
	
	public function indexAction()
	{
		$oForm = new Application_Form_Setting();
		$oForm->setDefaults($this->_oServiceSetting->getSettings());
		
        if ($this->getRequest()->isPost()) 
        {
            $aFormData = $this->getRequest()->getPost();
			
            if ($oForm->isValid($aFormData)) 
            {
            	unset($aFormData['save']);
            	$this->_oServiceSetting->updateSettings($aFormData);
				
				$this->_helper->flashMessenger->setNamespace('success')->addMessage('Settings have been saved.');		
				$this->_redirect('/settings');
			}
		}
		
		$this->view->oForm = $oForm;
	}
	
	public function advertisingAction()
	{
		$oForm = new Application_Form_Setting_Advertising();
		$oForm->setDefaults($this->_oServiceSetting->getSettings());
		
        if ($this->getRequest()->isPost()) 
        {
            $aFormData = $this->getRequest()->getPost();
			
            if ($oForm->isValid($aFormData)) 
            {
            	unset($aFormData['save']);
				
				$aSettings = $this->_oServiceSetting->getSettings();
				$this->_oServiceSetting->updateSettings($aFormData);
        		//$this->_helper->flashMessenger->setNamespace('error')->addMessage('This is not possible in the demo.');
				
				$this->_helper->flashMessenger->setNamespace('success')->addMessage('Settings have been saved.');
            	
				$this->_redirect('/settings/advertising');
			}
		}
		
		$this->view->oForm = $oForm;
	}
	
	public function userAction()
	{
		$oForm = new Application_Form_Setting_User();
		$oForm->setDefaults($this->_oServiceSetting->getSettings());
		
        if ($this->getRequest()->isPost()) 
        {
            $aFormData = $this->getRequest()->getPost();
			
            if ($oForm->isValid($aFormData)) 
            {
            	unset($aFormData['save']);
            	$this->_oServiceSetting->updateSettings($aFormData);
				
				$this->_helper->flashMessenger->setNamespace('success')->addMessage('Settings have been saved.');		
				$this->_redirect('/settings/user');
			}
		}
		
		$this->view->oForm = $oForm;
	}
}