<?php

class Application_Form_Auth_Create extends Zend_Form
{
    public function init()
    {
		$view = Zend_Layout::getMvcInstance()->getView();
		$this->setAction($view->baseUrl("/auth/create"));
		
        $this->setMethod('post');

        $this->addElement('text', 'firstName', array(
            'required'   => true,
            'filters'    => array('StringTrim'),
            'placeholder' => 'First Name',
        ));
		
        $this->addElement('text', 'lastName', array(
            'required'   => true,
            'placeholder' => 'Last Name',
            'filters'    => array('StringTrim'),
        ));

        $this->addElement('text', 'email', array(
            'required'   => true,
            'filters'    => array('StringTrim'),
            'placeholder' => 'eMail',
            'validators' => array(
                'EmailAddress',
            )
        ));

        // Add the comment element
        $this->addElement('password', 'password', array(
            'required'   => true,
            'placeholder' => 'Password',
            'validators' => array(
                array('validator' => 'StringLength', 'options' => array(0, 20))
			)
        ));

        // Add the submit button
        $this->addElement('submit', 'submit', array(
            'ignore'   => true,
            'label'    => 'Create your account',
            'class' => 'btn', 
            'style' => 'width:220px;'
        ));
    }
}