<?php

class Application_Form_Search extends Zend_Form
{
    public function init()
    {
    	$view = Zend_Layout::getMvcInstance()->getView();
		$this->setAction($view->baseUrl('/index/search'));
		$this->setAttrib('class', 'navbar-search pull-left');
        $this->setMethod('post');
		$this->setName('folderForm');
		
		$hidden = new Zend_Form_Element_Hidden('formName');
		$hidden->removeDecorator('label')->setValue('searchForm');
		$this->addElement($hidden);

        $search = new Zend_Form_Element_Text('search');
        $search
            ->setRequired(false)
			->setAttrib('placeholder', 'Search')
			->setAttrib('class', 'search-query')
			->setAttrib('autocomplete', 'off')
            ->addValidator('NotEmpty');

		$search->setDecorators(array(
    		'ViewHelper',
		    'Errors',
		    array('Label', array('tag' => 'label', 'placement' => 'prepend')),
		    array(array('data' => 'HtmlTag'), array('tag' => 'span'))
		));
		
		$search->removeDecorator('Label');
		
		$this->clearDecorators();
        $this->addDecorator('FormElements')
             ->addDecorator('HtmlTag', array('tag' => '<fieldset>'))
             ->addDecorator('Form');
			
        $this->addElement($search);
    }
}