<?php

class Application_Form_Upload extends Zend_Form
{
    public function init()
    {
    	$view = Zend_Layout::getMvcInstance()->getView();
		$this->setAction($view->baseUrl("/index/index"));
		$this->setAttrib('class', 'dropzone');
        $this->setAttrib('enctype', 'multipart/form-data');
        $this->setMethod('post');
		
        $file = new Zend_Form_Element_File('file');
		$file->setDestination(APPLICATION_UPLOADS_DIR);
        $file//->setLabel('File to upload:')
            ->setRequired(true)
            ->addValidator('NotEmpty')
            ->addValidator('Count', false, 1);
		$file->setAttrib('style', 'display:none;');
        $this->addElement($file);

        $description = new Zend_Form_Element_Text('description');
        $description//->setLabel('Description')
            ->setRequired(false)
            ->addValidator('NotEmpty');
		$description->setAttrib('style', 'display:none;');
        $this->addElement($description);

        $this->addElement('submit', 'submit', array(
            'label'    => 'Upload',
            'ignore'   => true,
            'class' 	=> 'btn btn-primary',
            'style' => 'display:none;'
        ));
		
		$this->setDecorators(
			array(
				'FormElements',
			array('HtmlTag', array('tag' => 'dl', 'style' => 'position:absolute;')),
				'Form'
		));
		 
    }
}