<?php

class Application_Form_User extends Zend_Form {
	
    public function init() {
    	
		$this->setName('newUserForm');
		$view = Zend_Layout::getMvcInstance()->getView();
		//$this->setAction($view->baseUrl());
		
		$this->addElement('text', 'firstName', array(
            'filters'    => array('StringTrim'),
            'required'   => true,
            'placeholder'      => 'first name',
            'validators' => array(
				array('validator' => 'StringLength', 'options' => array(0, 50))
			)
        ));
		
		$this->addElement('text', 'lastName', array(
            'filters'    => array('StringTrim'),
            'required'   => true,
            'placeholder'      => 'last name',
            'validators' => array(
				array('validator' => 'StringLength', 'options' => array(0, 50))
			)
        ));
		
		$this->addElement('text', 'password', array(
            'filters'    => array('StringTrim'),
            'required'   => false,
            'placeholder' => 'password',
            'description' => 'Password length minimum: 5',
            'validators' => array(
				array('validator' => 'StringLength', 'options' => array(5, 50))
			)
        ));
				
		$this->addElement('text', 'email', array(
            'filters'    => array('StringTrim'),
            'placeholder'      => 'eMail',
            'required' => true,
            'validators' => array(
				array('validator' => 'StringLength', 'options' => array(0, 50)),
			)
        ));
		$this->getElement('email')->addValidator('EmailAddress');
		
		$this->addElement('select', 'active', array());
        $this->getElement('active')->addMultiOptions(array(
			Service_User::USER_STATE_ACTIVE => 'active',
			Service_User::USER_STATE_INACTIVE => 'inactive' 
		));    

		$this->addElement('select', 'privilege', array());
        $this->getElement('privilege')->addMultiOptions(array(
			Service_User::PRIVILEGE_USER => 'user',
			Service_User::PRIVILEGE_ADMIN => 'admin' 
		));   
		
		$this->addElement('select', 'upload', array(
			'label' => 'The user has permission to upload files?'
		));
        $this->getElement('upload')->addMultiOptions(array(
			Service_User::FUNCTION_ALLOWED => 'Yes',
			Service_User::FUNCTION_NOT_ALLOWED => 'No' 
		));
		
		$this->addElement('select', 'folder', array(
			'label' => 'The user has permission to create and delete folders?'
		));
        $this->getElement('folder')->addMultiOptions(array(
			Service_User::FUNCTION_ALLOWED => 'Yes',
			Service_User::FUNCTION_NOT_ALLOWED => 'No' 
		));   
		
		$this->addElement('select', 'delete', array(
			'label' => 'The user has permission to delete files?'
		));
        $this->getElement('delete')->addMultiOptions(array(
			Service_User::FUNCTION_ALLOWED => 'Yes',
			Service_User::FUNCTION_NOT_ALLOWED => 'No' 
		));   
		
		$this->addElement('select', 'link', array(
			'label' => 'The user has permission to link files?'
		));
        $this->getElement('link')->addMultiOptions(array(
			Service_User::FUNCTION_ALLOWED => 'Yes',
			Service_User::FUNCTION_NOT_ALLOWED => 'No' 
		));   
		
        $login = $this->addElement('submit', 'save', array(
            'required' => false,
            'ignore'   => true,
            'label'    => 'Save',
			'class' 	=> 'btn btn-success'
        ));
    }
}