<?php

class Service_Controller_Action extends Zend_Controller_Action {
	
	protected $_sPrivilege;
	protected $_aSettings;

	public function init() {
		$sAction = $this->getRequest()->getActionName();
		
		if (!Zend_Auth::getInstance()->hasIdentity() && $sAction != 'password') {
			$this->_redirect('auth/login');
		}
		
		// Daten zum Benutzer aus der Session holen.
		$oStorage = new Zend_Auth_Storage_Session();
		$this->view->oUser = $oStorage->read();
	
		// Load application.ini
		$oBootstrap = Zend_Controller_Front::getInstance()->getParam('bootstrap');
	    $aOptions = $oBootstrap->getOptions();
		$this->view->aOptions = $aOptions;
		
		// Load Settings
		$oServiceSetting = new Service_Setting();
		$this->_aSettings = $oServiceSetting->getSettings();
		$this->view->aSettings = $this->_aSettings;
		
		// Load User privilege.
		$oStorage = new Zend_Auth_Storage_Session();
		$oUser = $oStorage->read();
		$this->view->sPrivilege = $oUser->privilege;
		
		$this->_sPrivilege = $oUser->privilege;
	}

	public function postDispatch() {
		parent::postDispatch();
		$this->view->messages = $this->_helper->flashMessenger->getMessages();
	}
}