<?php

class Service_Mail {
	
	const MAIL_FROM = 'do-not-reply@domain.de';
	const MAIL_FROM_NAME = 'MonsterFile';
	
	protected $_oMail;
	protected $_oView;
	protected $_oTransport;
	protected $_aSettings;
	
	public function __construct() 
	{
		$oServiceSetting = new Service_Setting();
		$this->_aSettings = $oServiceSetting->getSettings();
		
		$this->_oMail = new Zend_Mail('utf-8');
		$this->_oMail->setFrom(self::MAIL_FROM, self::MAIL_FROM_NAME);
		
		$this->_oMail->setReplyTo(self::MAIL_FROM, self::MAIL_FROM_NAME);
		$this->_oMail->addHeader('MIME-Version', '1.0');
		$this->_oMail->addHeader('Content-Transfer-Encoding', '8bit');
		$this->_oMail->addHeader('X-Mailer:', 'PHP/'.phpversion());
		
		$this->_oView = new Zend_View();
		$this->_oView->setScriptPath(APPLICATION_PATH . '/views/emails/');
	}
	
	public function newUserMail($iUserId)
	{
		$oServiceUser = new Service_User();
		$oUser = $oServiceUser->getUser($iUserId);
		
		if ($oUser)
		{
			// render view
			$this->_oView->assign('oUser', $oUser);
			$bodyText = $this->_oView->render('newUser.phtml');
			
			$this->_oMail->addTo($this->_aSettings['email'], "Admin MonsterFile");
		    $this->_oMail->setSubject('New user registration');
			$this->_oMail->setBodyText($bodyText);
		    $this->_oMail->setBodyHtml($bodyText);
		    $this->_oMail->send();
		}
	}

	/**
	 * Reset password mail.
	 * 
	 * @param int $iUserId 
	 */
	public function sendPasswordMail($sMail)
	{
		$oServiceUser = new Service_User();
		$oModelUser = new Application_Model_User();
		$oUser = $oModelUser->fetchRow($oModelUser->select()->where('email = ?', $sMail));
		
		if (!is_null($oUser))
		{
			$sNewPassword = $oServiceUser->createPassword(8);
			$this->_oView->assign('oUser', $oUser);
			$this->_oView->assign('sPassword', $sNewPassword);
			
			$oServiceUser->updateUser(array('password' => $sNewPassword), $oUser->user_id, false);
	
			// render view
			$bodyText = $this->_oView->render('password.phtml');
			
			$this->_oMail->addTo($oUser->email, $oUser->firstName . ' ' . $oUser->lastName);
		    $this->_oMail->setSubject('Your new MonsterFile password');
			$this->_oMail->setBodyText($bodyText);
		    $this->_oMail->setBodyHtml($bodyText);
		    $this->_oMail->send();
		}
	}
}