<?php

abstract class Service_Structure
{
	const RAND_STRING_LENGTH = 8;
	
	/**
	 * Generate a unique key.
	 * 
	 * @param Application_Model_Abstract $oModel
	 * @return String | boolean
	 */
	public function createUniqueKey(Application_Model_Abstract $oModel)
	{
		for ($i = 0; $i < 10; $i++)
		{
			$sRandString = $this->randString(self::RAND_STRING_LENGTH);
			$oEntry = $oModel->fetchRow($oModel->getForeignKey() . " = '" . $sRandString . "'");
			
			if (is_null($oEntry))
			{
				return $sRandString;
			}
		}
		
		return false;
	}
	
	/**
	 * Delivers the real id.
	 * 
	 * @param String $sKey
	 * @param Object $oModel
	 * 
	 * @return int | null
	 */
	public function getIdToKey($sKey, Application_Model_Abstract $oModel)
	{
		$oEntry = $oModel->fetchRow($oModel->getForeignKey() . " = '" . $sKey . "'");
		
		if (!is_null($oEntry))
		{
			// FIX: "Strict Standards: Only variables should be passed by reference in..."
			$oTempModel = $oModel;
			$iPrimaryKey = $oTempModel->getPrimaryKey();
			$sFieldName = array_shift($iPrimaryKey);
			return $oEntry->$sFieldName;
		}
		else
		{
			return null;
		}
	}
	
	/**
	 * Generate a random String.
	 * 
	 * @param int $iStringLength
	 * @return String
	 */
	private function randString($iStringLength) { 
	    srand ((double)microtime()*1000000); 
	    $iRand = rand(); 
	    return substr(md5($iRand) , 0, $iStringLength); 
	}   
}